#define VERSION "0.8.8"

/* Default video device */
#define VIDEO_DEV       "/dev/video0"

/* Default output directory */
#define BASEDIR "."

/* Default capture size */
#define DEF_WIDTH       320
#define DEF_HEIGHT      240

/* Default input port 
 * usually, tv = 0, composite1 = 1, composite2 = 2, svideo = 3.
 * if specify -1 here and if only 1 channel (such as ov511 webcam) supported 
 * by your device, then mvc will use channel 0 as input, if more than 1 channels 
 * supported by your device (such as most bttv card), it will use channel 1 
 * as input, because most tv card use channel 0 as tv input, so skip it. 
 */
#define IN_DEFAULT      -1

/* Default video norm, defined in videodev.h */
#define NORM_DEFAULT    VIDEO_MODE_PAL

/* Default brightness and contrast value (0-65535) */
#define DEF_BRIGHTNESS  32768
#define DEF_CONTRAST  	32768

/* Default screen divider */
#define DEF_BLK_X	16
#define DEF_BLK_Y	8

/* Default block color diff threshold */
#define DEF_COLOR_TS	50

/* Default interval for sample rate (sec) */
#define DEF_INTERVAL	0.3

/* this multiplier used for slow motion detection. 
   Usually, this value is good enough. To disable 
   slow motion detect, set 0 here. */
#define SLOW_COUNT_MAX	60

/* Default output format */
#define DEF_FMT		FMTJPEG

#define FMTJPEG		1
#define FMTPNG		2

/* Default JPEG file quality */
#define QUAL_DEFAULT    90

/* Default verbose level for message output */
#define DEF_VERBOSE	1

/* Print timestamp on image or not.
 * FONTSIZE, font6x11 for smaller, font8x16 for bigger 
 */
#define PRINT_TIME	0
#define FONTSIZE	font6x11


