#!/bin/sh
CC=${CC-gcc}
CFLAGS=${CFLAGS-'-O2 -Wall -g -I.'}
LIBS=''
DEFS=''

compile='rm -f conftest.o ; $CC $CFLAGS $CFLAGS2 $TESTLIBS conftest.c -o conftest &> /dev/null'

#test libjpeg
[ -f conftest ] && rm -f conftest
cat << XEOF > conftest.c
#include <stdio.h>
#include <jpeglib.h>
main()
{
    struct jpeg_compress_struct cjpeg;
    struct jpeg_error_mgr jerr;
    cjpeg.err = jpeg_std_error(&jerr);
    jpeg_create_compress(&cjpeg);
}
XEOF
TESTLIBS='-ljpeg'
eval $compile
if [ -f conftest ] ; then
  LIBS="$LIBS -ljpeg"
  DEFS="$DEFS -DHAVE_JPEG"
else
  echo "WARNING: libjpeg NOT Found."
fi

#test libpng
[ -f conftest ] && rm -f conftest
cat << XEOF > conftest.c
#include <stdio.h>
#include <png.h>
main()
{
    png_structp png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING,
                                                  NULL, NULL, NULL);
}
XEOF

TESTLIBS='-lpng'
if which libpng-config &> /dev/null ; then
    CFLAGS2=`libpng-config --cflags`
    TESTLIBS=`libpng-config --libs` 
else if which pkg-config &> /dev/null ; then 
	for libpng in libpng libpng12 libpng10 nolibpng.pc; do
           if pkg-config --exists $libpng ; then 
		break;
	   fi
	done
	if [ "$libpng" != "nolibpng.pc" ] ; then
		CFLAGS2=`pkg-config --cflags $libpng`
    		TESTLIBS=`pkg-config --libs $libpng`
	fi
    fi
fi
eval $compile
if [ -f conftest ] ; then
  CFLAGS="$CFLAGS $CFLAGS2"
  LIBS="$LIBS $TESTLIBS"
  DEFS="$DEFS -DHAVE_PNG"
else
  echo "WARNING: libpng NOT Found."
fi

rm -f conftest.c conftest

echo LIBS=$LIBS > depend.inc
echo CFLAGS=$CFLAGS >> depend.inc
echo DEFS=$DEFS >> depend.inc

