#include <stdio.h>
#include "mvc.h"

#define FONTWIDTH	8
#define FONTHEIGHT	13


char mask_0[] = { 0x00, 0x1c, 0x36, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x63, 0x36, 0x1c, 0x00 };
char mask_1[] = { 0x00, 0x0c, 0x1c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x1e, 0x00 };
char mask_2[] = { 0x00, 0x3e, 0x63, 0x43, 0x03, 0x06, 0x0c, 0x18, 0x30, 0x60, 0x63, 0x7f, 0x00 };
char mask_3[] = { 0x00, 0x3e, 0x63, 0x01, 0x01, 0x07, 0x1e, 0x07, 0x01, 0x01, 0x63, 0x3e, 0x00 };
char mask_4[] = { 0x00, 0x06, 0x0e, 0x0e, 0x1e, 0x16, 0x36, 0x26, 0x66, 0x7f, 0x06, 0x06, 0x00 };
char mask_5[] = { 0x00, 0x7f, 0x60, 0x60, 0x60, 0x7e, 0x7f, 0x03, 0x03, 0x03, 0x67, 0x7e, 0x00 };
char mask_6[] = { 0x00, 0x3e, 0x63, 0x60, 0x60, 0x7e, 0x77, 0x63, 0x63, 0x63, 0x77, 0x3e, 0x00 };
char mask_7[] = { 0x00, 0x7f, 0x63, 0x66, 0x06, 0x0c, 0x0c, 0x0c, 0x18, 0x18, 0x18, 0x18, 0x00 };
char mask_8[] = { 0x00, 0x3e, 0x77, 0x63, 0x63, 0x77, 0x3e, 0x77, 0x63, 0x63, 0x77, 0x3e, 0x00 };
char mask_9[] = { 0x00, 0x1c, 0x36, 0x63, 0x63, 0x63, 0x37, 0x1f, 0x03, 0x03, 0x36, 0x3c, 0x00 };
char mask_ms[] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00 };
char mask_sl[] = { 0x00, 0x02, 0x06, 0x04, 0x0c, 0x08, 0x18, 0x10, 0x30, 0x20, 0x60, 0x40, 0x00 };
char mask_dd[] = { 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00 };
char mask_sp[] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

char *fonttab[256];

void fontinit()
{
    int i;
    for (i = 0; i <= 255; i++) {
	fonttab[i] = NULL;
	fonttab['0'] = mask_0;
	fonttab['1'] = mask_1;
	fonttab['2'] = mask_2;
	fonttab['3'] = mask_3;
	fonttab['4'] = mask_4;
	fonttab['5'] = mask_5;
	fonttab['6'] = mask_6;
	fonttab['7'] = mask_7;
	fonttab['8'] = mask_8;
	fonttab['9'] = mask_9;
	fonttab['-'] = mask_ms;
	fonttab['/'] = mask_sl;
	fonttab[':'] = mask_dd;
	fonttab[' '] = mask_sp;
    }
}

int gputch(IMG image, int x0, int y0, int ch, RGB24 color)
{
    int i, j, w;
    char *buf;
    char *fontmask;
    char fontline;
    int p;

    w = image.width;
    buf = image.buf;

    if ((x0 + FONTWIDTH > w) || (y0 + FONTHEIGHT > image.height))
	return -1;
    if ((fontmask = fonttab[ch]) == NULL)
	return 1;
    for (i = 0; i < FONTHEIGHT; i++) {
	fontline = fontmask[i];
	for (j = 0; j < FONTWIDTH; j++) {
	    if ((fontline << j) & 0x80) {
		p = ((y0 + i) * w + x0 + j) * 3;
		buf[p] = color.red;
		buf[p + 1] = color.green;
		buf[p + 2] = color.blue;
	    }
	}
    }
    return 0;
}

int gputs(IMG image, int x0, int y0, char *str, RGB24 color)
{
    int i = 0;
    char ch;
    while ((ch = *(str++)) != 0) {
	if (gputch(image, x0 + i * (FONTWIDTH + 1), y0, ch, color) < 0) {
	    return -1;
	}
	i++;
    }
    return 0;
}
